unit Unit1; 

{$mode objfpc}{$H+}

interface

{.$define BUG1}

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons, Menus;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    PopupMenu1: TPopupMenu;
    SystrayIcon: TTrayIcon;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  PopupMenu1.Items.Clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
{$ifdef BUG1}
  SystrayIcon := TTrayIcon.Create(Self);

  SystrayIcon.Icon.LoadFromFile('/Users/felipemonteirodecarvalho/Programas/qt_menu/icon3.ico');

  SystrayIcon.PopUpMenu := PopupMenu1;

  SystrayIcon.Visible := True;
{$endif}
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
var
  Item: TMenuItem;
begin
{$ifdef bug1}
  PopupMenu1.Free;
  Application.ProcessMessages;
  PopupMenu1 := TPopupMenu.Create(Self);
{$else}
  PopupMenu1.Items.Clear;
{$endif}

  Item := TMenuItem.Create(Self);
  Item.Caption:= 'blabla';

  PopupMenu1.Items.Add(Item);

  Item := TMenuItem.Create(Self);
  Item.Caption:= 'blabla_clickme';
  Item.OnClick:= @MenuItem2Click;

  PopupMenu1.Items.Add(Item);

  Self.PopupMenu := PopupMenu1;
end;

initialization
  {$I unit1.lrs}

end.

